#ifndef __FKUT_APP_BASE_H__
#define __FKUT_APP_BASE_H__

#include <FK/FK.h>
#include "FKUT/FrameController.h"
#include "FKUT/Fullscreen.h"
#include "FKUT/Input.h"
#include "FKUT/EventManager.h"

// AppBase gAv̍

// 1. fkut_AppBase pNX
// 2. protected(private) oɎgϐ錾
// 3. init()Ƀ[v˓ỎW񂵂Ď
// 4. update()ɃC[v1񕪂̏(܂ȂQ͕sv)
// 5. oCpXRXgN^(fXgN^ꉞ`Ă)
// 6. main() Fl_Window, fk_Window Ǝ̍NX̕ϐ錾
// 7. main() run()Ăяo΃AvX^[gAIŖ߂Ă

enum fkut_LoopState {
	FKUT_EXIT,
	FKUT_RUNNING,
	FKUT_SLEEPING
};

class fkut_AppBase {
public:
	fkut_AppBase(Fl_Window *argMainWin, fk_Window *argDrawWin);
	virtual ~fkut_AppBase(void);

	int				run(void);

protected:
	Fl_Window	*mainWin;
	fk_Window	*drawWin;

	fkut_Input	input;
	bool		inputReady;

	fkut_FrameController	fps;
	CFullscreenControler	fsc;
	EventManager			eveMan;

	fkut_LoopState	ProcWindow(void);

	void			Sleep(unsigned long);
	void			ToggleScreen(void);

	virtual void	init(void) = 0;
	virtual bool	update(void) = 0;
};

#endif
